<?php
/**
 * @copyright	Copyright (C) 2005 - 2012 Henk von Pickartz
 * @license		GNU General Public License version 2 or later
 * This plugin is created based on the SKELETON plugin on http://atlanticintelligence.net
 * SimpleCaddy coupon plugin v1.0 for SimpleCaddy 2.x and Joomla 2.5
 */

// No direct access.
defined('_JEXEC') or die;
require_once (JPATH_ROOT.DS.'components'.DS.'com_simplecaddy'.DS.'simplecaddy.class.php');
require_once (JPATH_ROOT.DS.'components'.DS.'com_simplecaddy'.DS.'simplecaddy.cart.class.php');

/** 
 * configuration class 
 */

class sccouponsconfiguration extends JTable { // this is the standard configuration class for the plugin
// naming is {pluginname}configuration
	var $id;
	var $couponcode;
	var $timelimited;
	var $numberlimited;
	var $expiry; 
	var $num_avail; 
	var $product_specific; 
	var $prod_codes; 
	var $value_type; 
	var $value; 
	var $published; 

	function sccouponsconfiguration() { // initialise class and check if data table exists. If not, create it
		// Load plugin language, since we use it in the backend, standard language loading is NOT performed
		$lang = JFactory::getLanguage();
		$lang->load('plg_content_sccoupons', JPATH_ADMINISTRATOR);
		$db	=& JFactory::getDBO();
		// next 2 lines: suppress any legitimate errors on checking if the table exists
	   	@$this->__construct( '#__sc_coupons', 'id', $db );
		if (@count($db->getTableColumns($this->_tbl))==0 ) {
			// no columns found, so we need to create the table
			$query= "CREATE TABLE `#__sc_coupons` (
					`id`  int NOT NULL AUTO_INCREMENT ,
					`couponcode`  varchar(32) NOT NULL ,
					`timelimited`  int NOT NULL ,
					`numberlimited`  int NOT NULL ,
					`expiry`  int NULL ,
					`num_avail`  int NULL ,
					`product_specific`  int NOT NULL ,
					`prod_codes`  text NULL ,
					`value_type`  int NULL ,
					`value`  varchar(64) NOT NULL ,
					`published`  int NOT NULL ,
					PRIMARY KEY (`id`),
					UNIQUE INDEX `couponcode` (`couponcode`) 
					)
					;";
			$this->_db->setQuery($query);
			$this->_db->query();
		};
	}
	
	function addnew() {
		$this->editcoupon();
	}
	
	function edit() {
		$toedit=JRequest::getVar("cid");
		$this->editcoupon($toedit[0]);
	}
	
	function remove() {
		$todelete=JRequest::getVar("cid");
		foreach($todelete as $key=>$id) {
			$this->delete($id);
		}
		$mainframe=JFactory::getApplication();
		$url="index.php?option=com_simplecaddy&action=pluginconfig&task=showpluginconfig&pluginname=sccoupons";
		$mainframe->redirect($url);
	}
	
	function publish() {
		$cid=JRequest::getVar("cid");
		foreach ($cid as $key=>$id) {
			$this->load($id);
			$this->published=1;
			$this->store();
		}
		$url="index.php?option=com_simplecaddy&action=pluginconfig&task=showpluginconfig&pluginname=sccoupons";
		$mainframe=JFactory::getApplication();
		$mainframe->redirect($url);
	}

	function unpublish() {
		$cid=JRequest::getVar("cid");
		foreach ($cid as $key=>$id) {
			$this->load($id);
			$this->published=0;
			$this->store();
		}
		$url="index.php?option=com_simplecaddy&action=pluginconfig&task=showpluginconfig&pluginname=sccoupons";
		$mainframe=JFactory::getApplication();
		$mainframe->redirect($url);
	}

	function save() { // mandatory function to save any variables
		$this->bind($_REQUEST); // get all the fields from the admin form
		$this->expiry=strtotime($this->expiry);
		$b=$this->store(); // store the relevant fields only
		if ($b) {
			$msg=JText::_("SCC_COUPON_SAVED");
		}
		else
		{
			$msg=JText::_("SCC_COUPON_NOT_SAVED");
			$msg .= " " . $this->_db->getErrorMsg();
		}
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=pluginconfig&task=showpluginconfig&pluginname=sccoupons", $msg);
	}

	function cancel() {
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=pluginconfig&task=showpluginconfig&pluginname=sccoupons");
	}
	
	function pluginlist() {
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=plugins");
	}
	
	function get($key) { // retrieves voucher key from storage
		$query="select `id` from `$this->_tbl` where `couponcode` = '$key'";
		$this->_db->setQuery($query);
		$id=$this->_db->loadResult(); 
		$this->load($id);
	}
	
	function getlist($sort=null, $sorttype="ASC") {
		$query=" select * from `$this->_tbl` ";
		if ($sort) $query .= " ORDER BY `$sort` $sorttype ";
		$this->_db->setQuery($query);
		$lst=$this->_db->loadObjectList();
		return $lst;		
	}
	
	function editcoupon($id=null) {
		$this->load($id);
		require_once(JPATH_COMPONENT_SITE."/simplecaddy.class.php");
		JHTML::script('components/com_simplecaddy/js/datetimepicker.js' );
		display::header(); // while this would be better inside the display function, a plugin does not have access to this
		JToolBarHelper::title( JText::_( "SCC_SIMPLECADDY_EDIT_COUPON" ), 'generic.png');
		JToolbarHelper::custom("save", "save", "", JText::_("SCC_SAVE"), false); 
		JToolbarHelper::cancel(); 
		?>
		<form name="adminForm" method="post">
		<table class="admintable">
		<tr><th style="width:  150px;">&nbsp;</th><th>&nbsp;</th></tr>
		<tr><td>id</td><td><?php echo $this->id;?></td></tr>
		<tr><td><?php echo JText::_("SCC_COUPONCODE");?></td><td><input type="text" name="couponcode" value="<?php echo $this->couponcode;?>" /></td></tr>
		<tr><td><?php echo JText::_("SCC_TIME_LIMITED");?></td>
		<td>
			<?php
				$show_hide = array (JHTML::_('select.option', 0, JText::_('SCC_NO')), JHTML::_('select.option', 1, JText::_('SCC_YES')),);
				foreach ($show_hide as $value) {
					echo "<input type='radio' value='$value->value' name='timelimited' ".($this->timelimited==$value->value?' checked':'').">$value->text";
				}
			?>
			
			
		</td></tr>
		<tr>
		<td><?php echo JText::_("SCC_EXPIRES");?></td>
		<td>
			<input type="text" size="40" name="expiry" id="expiry" value="<?php echo ($this->expiry?date("d-m-Y h:i:s", $this->expiry):""); ?>"/>
			<?php echo "&nbsp;<a href=\"javascript:NewCal('expiry','ddMMyyyy',true ,24)\"><img src=\"components/com_simplecaddy/images/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"".JText::_("SCC_PICK_DATE")."\"/></a>"; ?>
		</td></tr>
		<tr><td><?php echo JText::_("SCC_NUMBER_LIMITED");?></td>
		<td>
			<?php
				$show_hide = array (JHTML::_('select.option', 0, JText::_('SCC_NO')), JHTML::_('select.option', 1, JText::_('SCC_YES')),);
				foreach ($show_hide as $value) {
					echo "<input type='radio' value='$value->value' name='numberlimited' ".($this->numberlimited==$value->value?' checked':'').">$value->text";
				}
			?>
		</td></tr>
		<tr><td><?php echo JText::_("SCC_NUM_AVAIL");?></td><td><input type="text" name="num_avail" value="<?php echo $this->num_avail;?>" size="5" /></td></tr>
		<tr><td><?php echo JText::_("SCC_PRODUCT_SPECIFIC");?></td>
		<td>
			<?php
				$show_hide = array (JHTML::_('select.option', 0, JText::_('SCC_NO')), JHTML::_('select.option', 1, JText::_('SCC_YES')),);
				foreach ($show_hide as $value) {
					echo "<input type='radio' value='$value->value' name='product_specific' ".($this->product_specific==$value->value?' checked':'').">$value->text";
				}
			?>
		</td></tr>
		<tr><td><?php echo JText::_("SCC_PRODCODES");?></td>
		<td>
			<textarea name="prod_codes" cols="60" rows="6"><?php echo $this->prod_codes;?></textarea>
		</td>
		</tr>
		<tr><td><?php echo JText::_("SCC_VALUE_TYPE");?></td>
		<td>
		<?php
			$options[0]=JText::_("SCC_PERCENTAGE");
			$options[1]=JText::_("SCC_FIXED");
		 	$dropdown = JHTML::_('select.genericlist', $options, 'value_type', 'class="inputbox"', 'value', 'text', $this->value_type);
			echo $dropdown;
		?>
		</td></tr>
		<tr><td><?php echo JText::_("SCC_VALUE");?></td><td><input type="text" name="value" value="<?php echo $this->value;?>" /></td></tr>
		<tr><td><?php echo JText::_("SCC_ENABLED");?></td>
		<td>
		<?php
			$show_hide = array (JHTML::_('select.option', 0, JText::_('SCC_NO')), JHTML::_('select.option', 1, JText::_('SCC_YES')),);
			foreach ($show_hide as $value) {
				echo "<input type='radio' value='$value->value' name='published' ".($this->published==$value->value?' checked':'').">$value->text";
			}
		?>
		</td></tr>
		</table>
		<input type="hidden" name="option" value="com_simplecaddy" />
		<input type="hidden" name="action" value="pluginconfig"/>
		<input type="hidden" name="pluginname" value="sccoupons"/>
		<input type="hidden" name="id" value="<?php echo $this->id;?>"/>
		<input type="hidden" name="boxchecked" />
		<input type="hidden" name="task" />
		</form>
		<?php
	}
	
	function _showconfig() { // mandatory function name, identical for all SC plugins
		require_once(JPATH_COMPONENT_SITE."/simplecaddy.class.php");
		display::header(); // while this would be better inside the display function, a plugin does not have access to this
		JToolBarHelper::title( JText::_( "SCC_SIMPLECADDY_COUPON_LIST" ), 'generic.png'); 
		JToolBarHelper::addNew( 'addnew', JText::_("SCC_ADDNEW") );
		JToolBarHelper::custom('edit',"edit", "edit", JText::_("SCC_EDIT"));
		JToolbarHelper::deleteList();
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::custom('pluginlist', 'back', '', 'Main', false);

		$rows=$this->getlist('couponcode');
		?>
		<form name="adminForm" method="post">
		<table class="adminlist">
		<tr>
		<th style="width: 15px;text-align: center;">
			<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $rows ); ?>);" />
		</th>
		<th><?php echo JText::_("SCC_COUPONCODE");?></th>
		<th><?php echo JText::_("SCC_TIME_LIMITED");?></th>
		<th><?php echo JText::_("SCC_EXPIRES");?></th>
		<th><?php echo JText::_("SCC_NUMBER_LIMITED");?></th>
		<th><?php echo JText::_("SCC_NUM_AVAIL");?></th>
		<th><?php echo JText::_("SCC_VALUE_TYPE");?></th>
		<th><?php echo JText::_("SCC_ENABLED");?></th>
		</tr>
		<?php
			$k = 0;
			for ($i=0, $n=count( $rows ); $i < $n; $i++) {
			$row = &$rows[$i];
			?>
			<tr class="<?php echo "row$k"; ?>">
			<td style="width: 15px;text-align: left;">
				<input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" />
			</td>
			<td>
			<a href="#edit" onclick="return listItemTask('cb<?php echo $i;?>','edit')">
			<?php echo $row->couponcode;?></a>
			</td>
			<td><?php echo ($row->timelimited==1? JText::_("SCC_YES"): JText::_("SCC_NO") );?></td>
			<td><?php echo ($row->timelimited==1? date("d-m-Y", $row->expiry):"");?></td>
			<td><?php echo ($row->numberlimited==1? JText::_("SCC_YES"): JText::_("SCC_NO") ) ;?></td>
			<td><?php echo ($row->numberlimited==1? $row->num_avail:"");?></td>
			<td><?php echo ($row->value_type==1? JText::_("SCC_FIXED"): JText::_("SCC_PERCENTAGE") );?></td>
			<td>
			<?php
				$published 	= JHTML::_('grid.published', $row, $i );
				echo $published;
			?>
			</td>
			</tr>
			<?php 
			$k= 1-$k;
		}
		?>
		</table>

		<input type="hidden" name="option" value="com_simplecaddy" />
		<input type="hidden" name="action" value="pluginconfig"/>
		<input type="hidden" name="pluginname" value="sccoupons"/>
		<input type="hidden" name="boxchecked" />
		<input type="hidden" name="task" />
		</form>
		<?php
	}

	function isincart() {
		$cart=new cart2();
		$validprodcodes=explode("\r\n", $this->prod_codes);
		foreach ($validprodcodes as $key=>$prodcode) {
			$valid=$cart->isInCart($prodcode);
			if ($valid) return true;
		}
		return false;
	}
	
	function check() {
		$couponcode=JRequest::getVar("coupon");
		$ordercode=JRequest::getVar("data");
		$id=JRequest::getVar("id"); // article content id
		$this->get($couponcode);
		$valid=true;
		$now=mktime();
		$msg="";
		if ( (@ $this->id) and ($this->published==1) ) {
			if ( ($this->numberlimited==1) and ($this->num_avail <=0)) $valid=false;
			if ( ($this->product_specific==1) and (!$this->isincart()) and ($valid)) $valid=false;
			if ( ($this->timelimited==1) and ($this->expiry <=$now) and ($valid) ) $valid=false;
			if ($valid) { // coupon code is valid, now determine the value
				if ($this->value_type==1) { // fixed
					$value=$this->value;
				}
				if ($this->value_type==0) { // percentage
					$cart=new cart2();
					$exclude=array("tax", "coupon");
					$ctotal=$cart->getCartTotal($exclude);
					$this->value=str_replace("%", "", $this->value);
					$this->value=str_replace(".", "", $this->value);
					$value= -1 * abs($ctotal * $this->value / 100);
				}
				$value=number_format($value, 2);
				$cart=new cart2();
				$cartprod=new CartProduct();
				$cartprod->unitprice=$value;
				$cartprod->prodcode="coupon";
				$cartprod->quantity=1;
				
				$cartprod->finalprice=$value;
				$cartprod->md5id=md5("coupon");
				$cart->removeCartProduct($cartprod); // remove any existing coupons first
				$cart->addCartProduct($cartprod);
				if (@$ordercode<>"") { // we are dealing with a saved order so we need to update the order as well
					$orders=new orders(); 
					$orderid=$orders->getOrderIdFromCart($ordercode); // now we have an order ID
					$order= new order();
					$order->load($orderid);
		    		$odet=new orderdetail();
		    		$odet->isinorder($orderid, $cartProd->prodcode);
		    		$odet->orderid=$orderid;
		    		$odet->prodcode="coupon";
		    		$odet->qty=1;
		    		$odet->unitprice=$value;
		    		$odet->total=$value;
		    		$odet->shorttext=$cartProd->prodname;
		    		$odet->option=$cartProd->option;
		            $odet->store();
		    		$gtotal=$order->total+$odet->total;
		    	
					$o = new order(); // reload the order
			        $o->load($orderid);
			    	$o->total=$gtotal; // update its grand total
			        $o->store(); // store the order with new total
				}
				$msg=JText::sprintf("SCC_COUPON_APPLIED", ($value) );
			}
		}
		else
		{
			$msg=JText::_("SCC_INVALID_COUPON");
		}
		
		// go back to where we came from
		$url =htmlspecialchars_decode(JRoute::_( ContentHelperRoute::getArticleRoute($id) ));
		if (strpos($url, "?")>0) {
			$url .= "&data=".$ordercode;
		}
		else
		{
			$url .= "?data=".$ordercode;
		}
		$mainframe=JFactory::getApplication();
		$mainframe->redirect($url, $msg);
	}
	
}

/**
 * Sccoupons plugin joomla standard part for frontend
 */
class plgContentSccoupons extends JPlugin { 
	var $_plugin_number	= 0; // plugin counter -- see below

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	public function _setPluginNumber() {
		$this->_plugin_number = (int)$this->_plugin_number + 1;
	}

	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// check if we are displaying standard content. If not, get outta here
		$canProceed = $context == 'com_content.article';
		if (!$canProceed) {
			return; // obviously you can imagine better ways of dealing with this, depending on the situation
		}
		
		// get parameters of the plugin set in admin
		$baserate= $this->params->get('baserate'); 
		
        // find the plugin code in the article text
		$regex = '/{(sccoupons)\s*(.*?)}/i'; // modify to the real name of your plugin
        $matches = array();
        preg_match_all( $regex, $article->text, $matches, PREG_SET_ORDER );

		// parse the command line into usable pieces
        $parms=array();
        foreach ($matches as $match) {
 			$this->_setPluginNumber();
			if ($this->_plugin_number==1) { // Example: get the stylesheet only ONCE per page, independently of the number of plugins on the page
				JHTML::stylesheet('sccoupons.css','plugins/content/sccoupons/css/');
				// on windows servers this may need to be changed to 
				// JHTML::stylesheet('sccoupons.css','plugins\content\sccoupons\css\' );
 			}

 			// the following will try to clean up any plugin command line
			$line=str_replace("&nbsp;", " ", $match[2]); // replace any html spaces with normal ones
            $line=str_replace(" ", "&", $line); // now change all the spaces to &
            $line=strtolower($line); // transform everything to lowercase so that won't bother anyone
			// we could even make sure there is no html like <span> tags left in the line due to TinyMCE or other editors inserting html
			// try that for yourself...
			
            parse_str( $line, $parms ); // use an integrated php function to transform the url string into an array of parameters

            if (!isset($parms['type'])) { // no type provided, probably just forgot...
            	$parms["type"]="unused"; // set it to the default type to make sure
            }

        	// get or define all different types of display we support
        	switch (strtolower($parms['type']) ) {
       			case "unused": // the default, if nothing has been provided
                	$html=$this->_showcouponentry($parms);
                	break;
        		default: // anything else provides an error message but should not crash the plugin or joomla!
                	$html=JText::_("SK_THIS_PLUGIN_TYPE_NOT_SUPPORTED"). " ({$parms['type']})";
        	}
            $article->text = preg_replace($regex, $html, $article->text, 1);
        }
        return false;
	}
	
	protected function _showcouponentry($commandline=array())	{
		$data=JRequest::getVar("data");
		$formname=uniqid("V");
		$html="<div class='sccoupondiv'>";
		$html .= "<form name='$formname' method='post'>";
		$html .= "<input class='sccouponinput' type='text' name='coupon'>";
		$html .= "<input class='sccouponsubmit' type='submit' name='submit' value='".JText::_("SCC_SUBMIT")."'>";
		$html .= "<input type='hidden' name='option' value='com_simplecaddy'>";
		$html .= "<input type='hidden' name='action' value='scplugins'>";
		$html .= "<input type='hidden' name='task' value='check'>";
		$html .= "<input type='hidden' name='pluginname' value='sccoupons'>";
		$html .= "<input type='hidden' name='data' value='$data'>";
		$html .= "</form></div>";

		return $html;
	}
	
	
}

